        function PFUMILI(Ai,Hname,Np,exda,Lexda,Nexda,funct,Nit,ipr)

!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  parallelization via MPI-package: A.P.Saposhnikov, 2009

!--------------- Np(>0) - number of parameters, no upper restriction for this vaLue

!--------------- Ai: parameters array  Ai(Np,6) 
!--------------- Ai(i,1) initiaL vaLues of parameters before start of FUMILIM,
!---------------        finaL ones after finish of FUMILIM  (anaLog of common/A/A(100))
!--------------- Ai(i,2) Parameter errors after finish of FUMILIM  (anaLog of common/SIGMA/SIGMA(100))       
!--------------- Ai(i,3) CoreLLation factor after finish of FUMILIM  (anaLog of common/R/R(100))       
!--------------- Ai(i,4) Parameter step restrictin  (anaLog of common/PL/PL(100)),
!---------------         parameter fixed, if Ai(i,4)<0d0, adjusted by FUMILIM, if Ai(i,4)=0d0,       
!--------------- Ai(i,5) Minimum aLLowed vaLue of Ai(i,1)        (anaLog of common/AL/AMN(100))       
!--------------- Ai(i,6) Maximum aLLowed vaLue of Ai(i,1)        (anaLog of common/AU/AMX(100))       

!--------------- hname: names for parameters array (character*(1-15)), dimension array(Np)
!--------------- Lazy user can write  hisq=FUMILIM(Ai,'*',Np,exda,Lexda,Nexda,funct,Nit,ipr),
!--------------- what means: no parameters names 

!--------------- exda: experimentaL points array exda(Lexda,Nexda), no upper restriction for Nexda 

!--------------- funct(x,a,df): user's function (shouLd be decLared as EXTERNAL in caLLing program,
!                where x(1:n) - arguments, a(1:Np) - fitted parameters, df(1:Np) - first derivatives,
!                user is free to define or not each df(i)
!                if funct(x,a,df) is Linear respectiveLy each a(i), user is free to define nothing in the Ai array,
!                and the task wiLL be soLved during 1 iteration (poLinomiaL fit, for exampLe)
!--------------- Nit: maximum aLLowed number of iteration

!--------------- ipr: a number, assosiated with fiLe name or screen(0,6) (use of '*' is impermissibLe)
!--------------- ipr < 0 : no print (for exampLe, during many track reconstruction)  

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	parameter(rp=1d-17,ap=1d-37)
	character*(*) hname(Np)
	character*15 hnamein
	character*19 filnewnam,filnewar
      aLLocatabLe :: indm(:,:),z0(:),z(:),nderiv(:),matrderiv(:,:)
      allocatable :: g(:),a(:),da(:),r(:),sigma(:),pl(:),amn(:),amx(:)
	allocatable :: indfrpar(:),indfrpar1(:),indboun(:)
	allocatable :: indfix(:),indderiv(:),indderivi(:),hnamein(:)
!    	dimension g(Np),a(Np),da(Np),r(Np),sigma(Np)
!      dimension pL(Np),amn(Np),amx(Np)
!	dimension indfrpar(Np),indfrpar1(Np),indboun(Np)
!      dimension  indfix(Np),indderiv(Np),indderivi(Np)
	common/NEDm/NED(2)
	common/fumstat/nn1stat,nn2stat
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z2(3)
	common/fuminput/hisqmax,integx,n1,n2
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	common/fumpL/pLcom,pLcom2
	common/fumirs/iflname,ioutput,filnewnam,filnewar(4)
	dimension exda(Lexda*Nexda)
	dimension Ai(Np,6)
      real tarray(2)
      EXTERNAL funct
	data eps/0.01d0/

!
!    Sap: MPI   (begin)
!
      common /mpi_fum/  mpi_size,  ! number of processes   = 1,2,...
     2                  mpi_rank,  ! current process rank  = 0,1,...,mpi_size-1
     3                  mpi_come,  ! external communicator (usually MPI_COMM_WORLD)
     4                  mpi_comi,  ! internal communicator 
     5                  mpi_data,  ! MPI kind of DataType (REAL or DOUBLE)
     6                  mpi_err,   ! current job err flag
     7                  mpi_out,mpi_fin   ! flag for I/O permitted (mpi_rank=0) 
      logical mpi_out,mpi_fin
      include 'mpif.h'
      data mpi_size/1/, mpi_rank/0/, mpi_come/MPI_COMM_WORLD/

      if(np==2.and.ipr.Lt.0.and.Ai(1,4).ge.0d0.and.Ai(2,4).ge.0d0) then
         PfumiLi=fumi2par(Ai,exda,Lexda,nexda,funct,Nit)
	   return
      endif
	   
      call MPI_INITIALIZED(mpi_fin,mpi_err)
      if(.not.mpi_fin) call MPI_INIT(mpi_err)      ! else init was done outside!
      mpi_data=MPI_DOUBLE_PRECISION
      call MPI_COMM_DUP(mpi_come,mpi_comi,mpi_err) ! for internal exchanges 
      call MPI_COMM_SIZE(mpi_comi,mpi_size,mpi_err)
      call MPI_COMM_RANK(mpi_comi,mpi_rank,mpi_err)
      mpi_out=(mpi_rank.eq.0)
      if (mpi_out) write(*,*) ' MPI-run using ',mpi_size,' processes.'
!      call MPI_BCast(exda,nexda*lexda,mpi_data,0,mpi_comi,mpi_err)
!--- Sap: MPI   (end)

	ned(1)=nexda
	ned(2)=Lexda 
	ipri=ipr
	if(.not.mpi_out) ipri=-1  ! Sap: MPI
      Niter=Nit
	niterc=Niter
	Npar=Np
	nfrpar=0

	nn=np*(np+1)/2
	aLLocate(Z0(nn+1),Z(nn+1),indm(np,np),       ! Sap: last word - for hisq broadcastind
     - g(np),a(np),da(np),r(np),sigma(np),pl(np),indfrpar(np),
     - indfrpar1(np),indboun(np),indfix(np),indderiv(np),indderivi(np),
     - amn(np),amx(np), hnamein(np),   stat=ierr)    ! Sap: and I took  np instead of nfrpar!

!   Sap: ,     ,    (Bill Gates)
!        , ,   ,   Allocate.
!            !!!   ,   !
!        ,    ,    
!           .
	  z0=0     ! 
	  z=0      ! 
	  g=0
        da=0
	  r=0
	  sigma=0
	  indfrpar=0
	  indfrpar1=0
	  indboun=0
	  indderiv=0
	  indderivi=0
      caLL makeindm(indm,np)             ! make indexes for Z-matrix
	   
      do i=1,npar
	   a(i)=Ai(i,1)
	   if(Ai(i,5).eq.0d0) Ai(i,5)=-1d37
	   amn(i)=Ai(i,5)
	   if(Ai(i,6).eq.0d0) Ai(i,6)=1d37
	   amx(i)=Ai(i,6)
	   pL(i)=Ai(i,4)
	   if(pL(i).Lt.0d0) then
	      indfix(i)=3
         eLse
		  indfix(i)=0
		  nfrpar=nfrpar+1
		  indfrpar(nfrpar)=i
         endif
      enddo 
      nzfr=nfrpar*(nfrpar+1)/2
	nx=Lexda-2
	iendfLg=initfum(exda,a,amn,amx,indfrpar,indboun)  ! check user errors
	if(iendfLg.ne.0) goto 999

      IF (ipri.ge.0) then
	     call fumiwelcom
	     call fumname(hname,hnamein,npar)
      endif

	caLL fumderiv(a,exda,funct,indfrpar,indderiv,indderivi) !find anaLyticaL derivatives

	nd=nnoderiv
	if(nd.eq.0) nd=1
      if(ierr.eq.0) Allocate(nderiv(nset),matrderiv(nd,nset),stat=ierr)   ! only after fumderiv we can do it!
	if((ierr).ne.0) then
		   write(ipri,*) '***PFumiLi : fataL stop, ',
     *   'not enough memory for aLLocatabLe arrays'
	   stop
      endif

!---------------------- redefinition of pL(i)=0 
      npL=0
      do n=1,nfrpar
	   i=indfrpar(n) 
	   if(pL(i).eq.0d0) then
	      npL=npL+1
	      if(indderivi(i).ne.0d0) then
	         plt=pLcom2
            else
		     pLt=pLcom
		     if(indboun(i).ne.0) pLt=min(0.6d0*(amx(i)-amn(i)),pLt)
               if(pLt.eq.pLcom.and.a(i).ne.0d0) pLt=abs(a(i))+1d-6
            endif
	      pL(i)=pLt
         endif
      enddo
	if(npL.ne.0.and.mpi_out) write(ipri,*) npL,
     &'restrictions for parameter step are defined by PFUMILI'

      NN2=0
      if(nnoderiv.ne.0) 
     *	caLL fumderiv2(a,exda,funct,indderiv,nderiv,matrderiv)
	NDF=ned(1)-Nfrpar+1
!-----START NEW ITERATION

      DO iiter=0,Niter
	  iiterc=iiter
	  nfixboun=0
	  nfixindef=0

!-----REPEAT ITERATION WITH SMALLER STEP, when jump over extremum take pLace
      comp=1d0
!	tres=dtime(tarray)

      do nn1=1,n1                !  n1=2
	   do msgz=1,1
	    caLL sgzopt
     *    (exda,funct,z0,g,a,pl,amx,indfrpar,indderiv,nderiv,matrderiv)
	   enddo
	   hisqndf=hisq/ndf
         IF (Iiter.eq.0) exit
	   if(nn1.eq.n1) exit
!	   SP=rp*hisq      !   FUMILI version	 		 
         SP=1d-5*hisq    !-- in difference with FUMILI
         IF (ABS(hisq-oLdhisq)<SP.AND.-EC<SP.and.hisq<oLdhisq)  exit
         T=(hisq-oLdhisq-EC-EC)
         IF ((0.59D0*T+EC).Lt.0d0)                   exit
         T=-EC/T
	   comp=comp*0.25d0
         IF (T.Lt.comp) T=comp
         EC=EC*T
         NN2=0
	   nn1stat=nn1stat+1

         DO n=1,Nfrpar
	      i=indfrpar(n)
		  a(i)=a(i)-da(i)
            if(nn1.eq.1) PL(I)=PL(I)*T
            DA(I)=da(i)*T
            A(I)=A(I)+da(i)
         enddo
      enddo    ! nn1=1,n1 

      do  !------------------------ boundary check

      do  mgc=1,0 !------------------------ mgconv 

!--------REMOVE FROM Z CONTRIBUTION OF PARAMETERS, FIXED DUE TO BOUND OR INDEFINITE
         Nfrpar1=0

         DO  n=1,Nfrpar
	     i=indfrpar(n)
           IF (indfix(I).ne.0) cycLe
           if(Z0(indm(n,n)).eq.0d0) then
	       indfix(i)=2
	       da(i)=0d0
		   nfixindef=nfixindef+1
		   cycLe
		 endif    

		 if(indboun(i).eq.1) then
             IF(AMX(I).LE.A(I).AND.G(I).Lt.0.D0.or.
     & 	   A(I).LE.AMN(I).AND.G(I).gt.0.D0) then
		     indfix(i)=1
			 da(i)=0d0
			 nfixboun=nfixboun+1
			 cycLe
             endif
           endif

           Nfrpar1=Nfrpar1+1
	     indfrpar1(Nfrpar1)=i
           k2=0 

           DO m=1,n
             IF (indfix(indfrpar(m)).ne.0) cycLe
		   k2=k2+1
             Z(indm(Nfrpar1,K2))=Z0(indm(N,m))
           enddo
         enddo ! n=1,Nfrpar
      
         caLL mgconvm(indm,z,r,indfix,indfrpar1)

	 if(ifixindef.eq.0) exit  ! from mgconv cycLe
	   nfixindef=nfixindef+ifixindef
      enddo  !------------------------ mgconv 
      do  mgc1=1,10 !------------------------ mgconvopt 

!--------REMOVE FROM Z CONTRIBUTION OF PARAMETERS, FIXED DUE TO BOUND OR INDEFINITE
         Nfrpar1=0

         DO  n=1,Nfrpar
	     i=indfrpar(n)
           IF (indfix(I).ne.0) cycLe
           if(Z0(indm(n,n)).eq.0d0) then
	       indfix(i)=2
	       da(i)=0d0
		   nfixindef=nfixindef+1
		   cycLe
		 endif    

		 if(indboun(i).eq.1) then
             IF(AMX(I).LE.A(I).AND.G(I).Lt.0.D0.or.
     & 	   A(I).LE.AMN(I).AND.G(I).gt.0.D0) then
		     indfix(i)=1
			 da(i)=0d0
			 nfixboun=nfixboun+1
			 cycLe
             endif
           endif

           Nfrpar1=Nfrpar1+1
	     indfrpar1(Nfrpar1)=i
           k2=0 

           DO m=1,n
             IF (indfix(indfrpar(m)).ne.0) cycLe
		   k2=k2+1
             Z(indm(Nfrpar1,K2))=Z0(indm(N,m))
           enddo
         enddo ! n=1,Nfrpar
      
         caLL mgconvopt(indm,z,r,indfix,indfrpar1)

	 if(ifixindef.eq.0) exit  ! from mgconv cycLe
	   nfixindef=nfixindef+ifixindef
      enddo  !------------------------ mgconv 

!-------CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION FACTOR
        ALAMBD=1.D0
        AKAPPA=0.D0
        AFIX=0.D0   
        IFIX=0   
        DO i1=1,Nfrpar1
	     i=indfrpar1(i1)
	     sigma(i)=sqrt(Z(indm(i1,i1)))
	     dai=-G(indfrpar1(1))*Z(indm(i1,1))
		 do L1=2,Nfrpar1
               dai=dai-G(indfrpar1(L1))*Z(indm(i1,L1))
           enddo
	     absdai=abs(dai)
		 da(i)=dai
		 akap=absdai/sigma(i)
		 if(akap.gt.akappa) akappa=akap
	     pLi=pL(i)
!------------------CHECK FOR PARAMETERS ON BOUNDARY
		 if(indboun(i).eq.1) then
             IF (dai.Le.0) then
		      pLi=min(pLi,(a(i)-amn(i)))
             eLse
		      pLi=min(pLi,(amx(i)-a(i)))
             endif
             IF (pLi.Le.0.D0) then
                IF (AKAP.gt.AFIX) then   
                   AFIX=AKAP   
                   IFIX=I
                endif
			  cycLe   
		   endif   ! end check 	      
           endif  !(indboun(i)==1
           if(absdai.ne.0) then ! Sap: avoid ZeroDiv
	       aLam=pLi/absdai
	       if(aLam.lt.aLambd)aLambd=aLam
	     endif
        enddo   !------------------------ theor step to minimum
	  if(ifix.eq.0) exit  ! from boundary check cycLe
        indfix(IFIX)=1
        nfixboun=nfixboun+1
      enddo   !------------------ boundary check 

!-----CALCULATE NEW CORRECTED STEP
      EC=0.D0
	amb=0.25/aLambd
      DO n=1,Nfrpar1
         i=indfrpar1(n)
	   absdai=abs(da(i))
	   reL=absdai/pL(i)
	   DA(I)=DA(I)*ALAMBD
         EC=EC+DA(I)*G(I)
	   IF (NN2.gt.N2.and.aLambd.Lt.0.5d0) then !-------  increase pL(I)
            if(rel.gt.amb) then
	         nn2stat=nn2stat+1
               PL(I)=PL(I)*4d0
	      endif
         endif
      enddo

!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      ndifpar=nfrpar-nfrpar1 
      IF (-EC.Le.SP.and.NN1.ne.1.and.ALAMBD.Lt.1.D0) then ! no futher decrease
         iendfLg=6
      eLseif (AKAPPA.Lt.EPS) then !  good finish
         if(nfrpar.eq.0) then  ! aLL parameters are fixed
		    iendfLg=7
         eLseif(nfrpar1.eq.nfrpar) then  ! no bound or indef parameters
		    iendfLg=1
         eLseif(nfrpar1.eq.0) then  ! aLL par  are indef  or fixed parameters
		    if(nfrpar.eq.nfixboun) then
			   iendfLg=3         ! aLL par are on bound
            eLse
		       iendfLg=8
            endif
         eLseif(ndifpar.eq.nfixboun) then  ! there are bound parameters
		    iendfLg=2
         eLseif(nfixindef.gt.0) then   ! there are indef parameters
		    iendfLg=5
         endif
	  eLse                                  !--------  akappa>eps                                           
         if(nfrpar1.eq.0) then  ! no free parameters
		    iendfLg=8
         eLse 
		    if(iiter.eq.niter) iendfLg=4
         endif
      endif

      if(ipri.ge.0) CALL MONITm (hnamein,a,ai,sigma,r,indfix)

      IF (iendfLg.ne.0) exit
	do n=1,nfrpar
	   i=indfrpar(n)
	   if(indfix(i).ne.0) then
	     indfix(i)=0
         eLse
	     a(i)=a(i)+da(i)
         endif
      enddo
      oLdhisq=hisq
      NN2=NN2+1

      ENDDO    !  iiter=0, niter
   
      PfumiLi=hisqndf
      do i=1,npar
	   if(indfix(i).eq.1) then
            Ai(i,1)=a(i)*0.999d0
         else
            Ai(i,1)=a(i)
         endif
         Ai(i,2)=sigma(i)
         Ai(i,3)=R(i)
	   Ai(i,4)=pL(i)
      enddo
	if(ipri.ge.0.and.hname(1).ne.'*') then
	  call fumnamfil(hname(1))      !TSap: was call fumnamfil(hname)
	  call fumisave(Ai,hname,npar,filnewnam)
	  if(ned(2).eq.3) call fumerrfun(A,exda,funct,z,pl,indfrpar1)
	  call SGZgrhi(a,exda,funct)
	  if(ipri.gt.100) then
	     if(nbad.ne.0) call sgzbp(a,exda,funct)
	  elseif(ipr.gt.200) then
           call fumerrexd(A,exda,funct,z,pl,indfrpar1)
        endif
      endif
 999  deaLLocate(Z0,Z,indm,g,a,da,r,sigma,pl,amn,amx,hnamein,
     - indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi,
     - nderiv,matrderiv)

      call MPI_BARRIER(mpi_comi,mpi_err)
      call MPI_COMM_FREE(mpi_comi,mpi_err)             ! TSap: delete internal communicator
      if(.not.mpi_fin) call MPI_FINALIZE(mpi_err)      ! else init was done outside

      RETURN
                END ! PFumiLi

                subroutine fumiwelcom
      IMPLICIT REAL*8 (A-H,O-Z)
	common/NEDm/NED(2)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fuminput/hisqmax,integx,n1,n2

	write(ipri,'(//)')
	write(ipri,*) ' FunctionaL Minimization by FUMILIM Function'
	write(ipri,*) 
     &' Here  EC: Expected Change in CHI^2/NDF During Next Step'
	write(ipri,*) '       KAPPA: Estimated Distance to Minimum' 
      write(ipri,*) '       LAMBDA: Step Length Modifier'
	write(ipri,'(/)')
	write(ipri,*) ' Number of ExperimentaL Points', ned(1)
	write(ipri,*) ' Iteration Limit is', niterc
	if(hisqmax.lt.1d36) write(ipri,'(A33,f3.1,A44)')
     &' Selection of events with chi^2<',hisqmax
     &  ,'*(chi^2/NDF from previous iteration) in use'
	return 
            end

            subroutine fumname(hname,hnamein,Np)
      character*(*) hname(np)
	character*15 hnamein(np)
	   hnamein='---------------'
	   if(hname(1).ne.'*') then
	      do i=1,np
	         Lr=Len(hname(i))
	         if(Lr.gt.15) Lr=15
	         if(Lr.Lt.1) cycLe
	         do j=Lr,1,-1
                  if(hname(i)(j:j).ne.' ') exit
		     enddo	  			       
	         hnamein(i)(1:j)=hname(i)(1:j)
	      enddo
	   endif
      return
	      end
	      subroutine fumnamfil(hname)
      parameter(nnam=5)
      character hname*(*),filnamin*19,filnewar*19,exten*4(nnam)
	common/fumirs/iflname,ioutput,filnewar(nnam)
	data exten/'.fm0','.hi0','.gr0','.bp0','.ap0'/

      if(iflname.ne.0) then
	   ist=2
      else
	   ist=1
	   ioutput=1
      endif
	namfile=' '
	jm=len(hname)
	if(jm>15) jm=15
	do j=jm,1,-1
         if(hname(j:J).ne.' ') then
	      js=j+1
	      je=j+4
	      exit
         endif   
	enddo
	do i=ist,nnam
         filnamin(1:j)=hname(1:j)
         filnamin(js:je)=exten(i)
         write(filnamin(je:je),'(i1)') ioutput
         filnewar(i)=filnamin
      enddo
	return
	        end		  

	      subroutine fumisave(ai,hname,npar,filname)
      IMPLICIT REAL*8 (A-H,O-Z)
	common/fuminput/hisqmax,integx,n1,n2
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/fumirs/iflname,ioutput
      character*(*) hname(npar),filname
      dimension ai(npar,6)
	
	open(999,file=filname)
	do i=1,npar
	   write(999,'(i6,3x,A15,3x,1p4E13.4)')i,hname(i),Ai(i,1),Ai(i,4:6)
      enddo
	if(iflname.eq.5) then
	   write(999,'(/e12.3,f10.3,2i5)') hisqmax,integx,n1,n2
	elseif(iflname.eq.4) then
	   write(999,'(/e12.3,f10.3,2i5)') hisqmax,integx,n1
	elseif(iflname.eq.3) then
	   write(999,'(/e12.3,f10.3,2i5)') hisqmax,integx
	elseif(iflname.eq.2) then
	   write(999,'(/e12.3,f10.3,2i5)') hisqmax
      endif 
	close(999)
      iflname=0
	return
	      end

	      subroutine fumiread(ai,hname,np,filname)
      IMPLICIT REAL*8 (A-H,O-Z)
	character*(*) filname,filnewnam*19,filnewar*19
      character*(*) hname(np)
      dimension ai(np,6)
	common/fuminput/hisqmax,integx,n1,n2
	common/fumirs/iflname,ioutput,filnewnam,filnewar(4)
      lf=len(filname)
      read(filname(lf:lf),'(i1)',err=2,iostat=iostat) is
2     if(iostat.ne.0) is=0
	lfn=lf
	if(lfn.gt.19) lfn=19
	filnewnam(1:lfn)=filname(1:lfn)
	ioutput=is+1
	if(ioutput.eq.10) ie=0
	write(filnewnam(lfn:lfn),'(i1)') ioutput
      open(999,file=filname)
	do i=1,np
	 read(999,*) j,hname(i),ai(i,1),ai(i,4:6)
      enddo
	read(999,*,end=1,iostat=iostat) hisqmax,integx,n1,n2
1	close(999)
      if(n2.ne.0) then
         iflname=5
      elseif(n1.ne.0) then
	   iflname=4
	elseif(integx.ne.0) then
	   iflname=3
	elseif(hisqmax.ne.0d0) then
	   iflname=2
      else
	   iflname=1
      endif
   
	return
	      end
 
            function FUMI2par(Ai,exda,Lexda,nexda,funct,Nit)

!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(maxpar=2)
	parameter(rp=1d-17,ap=1d-37)
      EXTERNAL funct
	common/NEDm/NED(2)
      COMMON /G2par/G(2)/A2par/A(2)/PL2par/PL(2)
	common /R2par/R(2)/der2par/indderiv(2),indderivi(2)
      dimension indfix(2),SIGMA(2),DA(2),df(2)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z2(3)
!	common/fuminput/hisqmax,integx,n1,n2
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	common/fumpL/pLcom,pLcom2
	dimension exda(Lexda*nexda),Ai(maxpar,6),indfrpar(2)
      data eps/0.01d0/,n1/2/,n2/1/
      Niter=Nit
	ipri=-1
	niterc=Niter
	ned(1)=nexda
	ned(2)=Lexda
	Npar=2
	Nfrpar=2
	nx=Lexda-2
      
	a(1)=Ai(1,1)
	a(2)=Ai(2,1)
!----------------------------- find defined derivatives
      k=3
	is=0
	indderivi(1)=0
	indderivi(2)=0
	df(1)=0d0
	df(2)=0d0
	Nnoderiv=0
      do i=1,ned(1)
        h=funct(exda(k),a,df)
	  do j=1,nfrpar
	     if(df(j).ne.0d0) then
		   if(indderivi(j).eq.0) then
		     indderivi(j)=1
	         is=is+1
             endif 
           endif 
        enddo
	  if(is.eq.nfrpar) exit
	  k=k+ned(2)
      enddo
	if(is.ne.nfrpar) then
         do i=1,nfrpar
            if(indderivi(i).eq.0) then
	        Nnoderiv=Nnoderiv+1
		    indderiv(Nnoderiv)=i
            endif 
         enddo
      endif 
!---------------------------- redefinition of pl(i)
	do i=1,2
	   pLt=Ai(i,4)
	   if(pLt.eq.0d0) then
	      if(indderivi(i).ne.0) then
		     pLt=pLcom2
            eLse
	         if(a(i).ne.0d0) then
		        pLt=abs(a(i))+1d-6
               else
	            pLt=plcom
		     endif
		  endif
         endif
	   pL(i)=pLt
      enddo

      NN2=0
      iendfLg=0
	NDF=ned(1)-1
	     
!-----START NEW ITERATION

      do iiter=0,Niter
	   iiterc=iiter

!-----REPEAT ITERATION WITH SMALLER STEP
      comp=1d0
      do nn1=1,n1   
	   caLL sgz2par(exda,funct)
	   hisqndf=hisq/ndf

         IF (Iiter.eq.0) exit
	   if(nn1.eq.n1) exit

         SP=1d-5*hisq
         IF (ABS(hisq-oLdhisq)<SP.AND.-EC<SP.and.hisq<oLdhisq)  exit
         T=(hisq-oLdhisq-EC-EC)
         IF ((0.59D0*T+EC).Lt.0d0)                   exit
         T=-EC/T
	   comp=comp*0.25d0
         IF (T.Lt.comp) T=comp
         EC=EC*T
         NN2=0

         DO i=1,2
 		  a(i)=a(i)-da(i)
            if(nn1.eq.1) PL(I)=PL(I)*T
            DA(I)=da(i)*T
            A(I)=A(I)+da(i)
         enddo
      enddo    ! nn1=1,n1 

      caLL mgconv2
      IF (ifixindef.ne.0) then
	    write(*,*) 'ridiculous event'
	    iendfLg=8
	    return
      endif

!-----CALCULATE THEORETICAL STEP TO MINIMUM and STEP CORRECTION
        aLambd=1d0
	  da(1)=-G(1)*Z2(1)-G(2)*Z2(2)
	  da(2)=-G(1)*Z2(2)-G(2)*Z2(3)
	  sigma(1)=sqrt(Z2(1))
	  sigma(2)=sqrt(Z2(3))
	  absda1=abs(da(1))
	  absda2=abs(da(2))
	  akappa=absda1/sigma(1)
	  akap2=absda2/sigma(2)
	  if(akap2.gt.akappa) akappa=akap2
	  AL1=pL(1)/absda1
	  if(AL1<aLambd) aLambd=AL1
	  AL2=pL(2)/absda2
	  if(AL2<aLambd) aLambd=AL2

       da(1)=da(1)*aLambd
       da(2)=da(2)*aLambd
       EC=da(1)*g(1)+da(2)*g(2)

      amb4=aLambd*4d0
      IF (NN2.gt.N2) then
	   if(AL1.lt.amb4) then
		  pL(1)=pL(1)*4d0
         endif
	   if(AL2.lt.amb4) then
	      pL(2)=pL(2)*4d0
         endif
      endif



!-----CHECK IF MINIMUM ATTAINED AND SET EXIT MODE
      IF (-EC.Le.SP.and.NN1.ne.1.and.ALAMBD.Lt.1.D0) then !no futher decrease
         iendfLg=1
      eLseif (AKAPPA.Lt.EPS) then !  good finish
		 iendfLg=1
	  eLse                                  !--------  akappa>eps                                           
		 if(iiter.eq.niter) iendfLg=4
      endif

      IF (iendfLg.ne.0) exit
	   do i=1,2
	      a(i)=a(i)+da(i)
         enddo
         oLdhisq=hisq
      NN2=NN2+1

      enddo    !  iiter=0, niter
      do i=1,2
        Ai(i,1)=a(i)
	  Ai(i,2)=sigma(i)
	  Ai(i,3)=r(i)
	  Ai(i,4)=pl(i)
      enddo
      fumi2par=hisqndf
      RETURN
                END ! Fumi2par


	   subroutine fumderiv(a,exda,funct,indfrpar,indderiv,indderivi)
!--------------------------- separation of analytical derivatives
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(minpar=30)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fuminput/hisqmax,integx,n1,n2
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
      common/NEDm/NED(2)
	dimension exda(ned(1)*ned(2))
      dimension a(npar),indfrpar(nfrpar)
	dimension indderiv(npar),df(npar),indderivi(npar)
	character*80 frm
	data frm/'(" Defined Derivatives:"i5"  of"i5" Free Parameters")'/

      nset=1
      do i=1,npar
	  df(i)=0d0
        indderivi(i)=0
      enddo
      Nnoderiv=0
	npL=0
      k=3

	is=0
      do i=1,ned(1)
        h=funct(exda(k),a,df)
	  do n=1,nfrpar
	     j=indfrpar(n)
		 if(indderivi(j).eq.0) then
	        if(df(j).ne.0d0) then
		     indderivi(j)=1
	         is=is+1
             endif 
           endif 
        enddo
	  if(is.eq.Nfrpar) exit
	  k=k+ned(2)
      enddo

      if(ipri.ge.0) write(ipri,frm) is,Nfrpar
	if(is.eq.Nfrpar) return

      do n=1,nfrpar
         i=indfrpar(n)
         if(indderivi(i).eq.0) then
	     Nnoderiv=Nnoderiv+1
		 indderiv(Nnoderiv)=i
         endif
      enddo
	if(nfrpar.gt.minpar.and.ned(2).gt.3) then
         if(integx>nx.or.integx<1)integx=nx
         k=integx+2
         do i=1,ned(1)
	      iset=exda(k)+0.5
	      absdx=abs(exda(k)-iset)
	      if(absdx.gt.1d-10) then
	         nset=1
	         exit
            endif
	      if(iset.gt.nset) nset=iset
	      k=k+ned(2)
         enddo
      endif

      RETURN
                END ! Fumderiv

	 subroutine fumderiv2(a,exda,funct,indderiv,nderiv,matrderiv)
!--------------------------- separation of parameters, corellated with i-set
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(minpar=30)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fuminput/hisqmax,integx,n1,n2
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
      common/NEDm/NED(2)
	dimension exda(ned(1)*ned(2))
      dimension a(npar),indfrpar(nfrpar)
	dimension indderiv(npar),df(npar),indderivi(npar)
	dimension nderiv(nset),matrderiv(nnoderiv,nset)
	allocatable::  memj(:,:)

      if(nset.eq.1) then
	   nderiv=nnoderiv
         matrderiv(1:nnoderiv,1)=indderiv(1:nnoderiv)
	   return
	endif
      allocate(memj(npar,nset))
	nderiv=0
	memj=0
!	matrderiv=0
      ind=integx+2
      k=-ned(2)
      do i=1,ned(1)
	   k=k+ned(2)
	   iset=exda(k+ind)
	   if(nx.eq.2.and.nderiv(iset).ne.0) cycle
	   h=funct(exda(k+3),a,df)
	   m=nderiv(iset)
         do n=1,nnoderiv
	      j=indderiv(n)
	      if(memj(j,iset).eq.0) then
	         amem=a(j)
	         a(j)=amem*1.1d0+1d-10
               h1=funct(exda(k+3),a,df)
	         a(j)=amem
	         if(h1.ne.h) then
	            m=m+1
	            matrderiv(m,iset)=j
	            memj(j,iset)=1
               endif
            endif
         enddo
	   nderiv(iset)=m
      enddo  ! i=1,ned(1)

      deallocate(memj)
      RETURN
                END ! Fumderiv2

                   function initfum(exda,a,amn,amx,indfrpar,indboun)
!---------------  author: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/NEDm/NED(2)
	dimension exda(ned(2),ned(1))
	dimension a(*),amn(*),amx(*),indfrpar(*),indboun(*)
	common/fuminput/hisqmax,integx,n1,n2
	common/fumpL/pLcom,pLcom2

	if(plcom.lt.1d3.or.plcom.gt.1d9) plcom=1d6
	if(plcom2.lt.plcom.or.plcom2.gt.1d18) plcom2=1d12
	if(eps.lt.1d-3.or.eps.gt.0.1) eps=0.01d0
	if(n1.lt.1.or.n1.gt.10) n1=6
	if(n2.lt.1.or.n2.gt.5) n2=1
	if(hisqmax.lt.0.5d0) hisqmax=1d37

 	ifataL=0

	if(ned(2).Lt.3) then
        write(ipri,"(//'**** PfumiLi: incorrect vaLue of Lexda=',i5//)")
     & 	 ned(2)
		 write(ipri,*)
     & 	 'Lexda - Length of one exp. point bLock: y,dy,x(1),x(2),...'
           write(ipri,*) 'shouLd be Lexda.gt.2'
		 ifataL=9
	     return
      endif

	do n=1,Nfrpar
	   i=indfrpar(n)
         if(amn(i).ge.amx(i)) then
		 write(ipri,
     &	 "('incorrect boundary condition for',i5,'th parameter: min='
     &     ,1pe12.4,'   max=',1pe12.4)")i,amn(i),amx(i)
		 write(ipri,*) 'shouLd be max > min'
		 ifataL=9
	   endif	   

	   if(amn(i).gt.-1d36.or.amx(i).Lt.1d36) then
		  indboun(i)=1
		  if(a(i).Lt.amn(i)) then
		     a(i)=amn(i)+1d-36
		     write(ipri,
     &	     "('value of',i5,'th parameter shifted to down edge')") i
            endif
		  if(a(i).gt.amx(i)) then
		     a(i)=amx(i)-1d-36
		     write(ipri,
     &	     "('value of',i5,'th parameter shifted to up edge')") i
            endif
         endif
	enddo

	if((ned(1)-Nfrpar).Lt.0) then
         write(ipri,"(//'**** PfumiLi: too few exp. points =',i5,
     & 	   '   shouLd be at Least Nexda=N(free)par'//)") ned(1)
	   ifataL=9
      endif

	if(ifataL.ne.0) then
	   write(ipri,"(/'***PfumiLi: fataL initiaL conditions error'//)")
      endif

	initfum=ifataL
	return
               END   ! initfum

        SUBROUTINE SGZopt
     *  (exda,funct,z,g,a,pl,amx,indfrpar,indderiv,nderiv,matrderiv)
!---------------   author: I.N. Silin
!---------------  upgrade: I.M. Sitnik, 2009
!         parallelization: A.P. Sapozhnikov, 2009
!-----SUBROUTINE SGZ SETS UP CHI^2,G(GRADIENT OF S) AND
!-----Z(APPROXIMATE COVARIANCE MATRIX)
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
      COMMON /NEDm/NED(2) !/X/X(20)
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fuminput/hisqmax,integx,n1,n2
	common/fumoutput/hisq,iendflg,iiterc,akappa,alambd,EC
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	dimension z(nzfr+1),g(npar),a(npar),pl(npar)
      dimension  indfrpar(nfrpar),indderiv(nfrpar)
      allocatable df(:),dfn(:),dummi(:),hi(:)
      dimension  x(nx),amx(npar)
	dimension nderiv(nset),matrderiv(nnoderiv,nset)
	dimension exda(*)

!  Sap: MPI
	include 'mpif.h'
      common /mpi_fum/  mpi_size,  ! number of processes   = 1,2,...
     2                  mpi_rank,  ! current process rank  = 0,1,...,mpi_size-1
     3                  mpi_come,  ! external communicator (usually MPI_COMM_WORLD)
     4                  mpi_comi,  ! internal communicator 
     5                  mpi_data,  ! MPI kind of DataType (REAL or DOUBLE)
     6                  mpi_err,   ! current job err flag
     7                  mpi_out    ! flag for I/O permitted (mpi_rank=0) 
      logical mpi_out
       
	integer st(MPI_STATUS_SIZE)
      allocatable :: gzbuf(:)
!          call profile(4)   !*****
! ---------

      allocate (df(npar),dfn(npar),dummi(npar),HI(npar))

      hisq=0d0
	nbad=0
      Z(1:nzfr)=0d0
	do i=1,npar
         g(i)=0d0
	   df(i)=0d0
      enddo
	if(iiterc==0) then
	    uplim=1d37
      else
	   uplim=hisqndf*hisqmax
      endif
	do n=1,Nnoderiv
	     i=indderiv(n)
           HIr=0.01d0*pl(i)
		 if((a(i)+HIr).gt.amx(i)) HIr=-HIr
		 HI(I)=HIr
      enddo

!      K2=-ned(2)
	ind=integx+2

!!! Sap: MPI      DO L1=1,ned(1)
      nn=ned(1)/mpi_size    ! number of points for 1 process
	n1=1+mpi_rank*nn      ! 1-st point
      k2=(n1-2)*ned(2)      !
	n2=n1+nn              ! last point
	if(mpi_rank.eq.mpi_size-1) n2=ned(1)
	nn=nfrpar+nzfr+1
      allocate(gzbuf(nn))   ! for buffering: hisq,G(nfrpar),Z(nzfr)
	gzbuf=0
!---
      DO L1=n1,n2
         K2=K2+NED(2)
         y=funct(exda(k2+3),a,df)
	   if(nset.eq.1) then
	      iset=1
         else
	      iset=exda(k2+ind)+0.5d0
         endif
         SIG=EXDA(K2+2)
         dysig=(Y-EXDA(K2+1))/sig
	   hisqi=dysig**2
         if(hisqi.gt.uplim) then
	      nbad=nbad+1
	      cycle
         endif
         hisq=hisq+hisqi

	   do n=1,Nderiv(iset)
	      i=matrderiv(n,iset)
            amem=A(I)
            A(I)=Amem+Hi(i)
		  DF(I)=(FUNCT(exda(k2+3),a,dummi)-Y)/HI(i)
            A(I)=Amem  !(i)
         enddo

         L=0
         DO n=1,Nfrpar
		  i=indfrpar(n)
		  if(df(i).eq.0d0) then
		     DFn(n)=0d0
		  else    
               DFt=DF(i)/SIG
               DFn(N)=DFt
               G(i)=G(i)+DFt*dysig
               gzbuf(1+i)=G(i)  ! Sap: MPI
		     do j=1,n
                  Z(L+j)=Z(L+j)+DFt*DFn(J)
                  gzbuf(L+j+1+nfrpar)=Z(L+j)  ! Sap: MPI
               enddo
		     df(i)=0d0
		  endif
            L=L+n
	   enddo

      enddo !  L1=1,ned(1)

      if(mpi_rank.eq.0) then
        do jj=1, mpi_size-1              ! receive from all others if any
          call mpi_Recv(gzbuf,nn,mpi_data,jj,0,mpi_comi,st,mpi_err)
	    hisq=hisq+gzbuf(1)
	    do i=1,nfrpar
	        G(i)=G(i)+gzbuf(i+1)
	    enddo
          do i=1,nzfr
	        Z(i)=Z(i)+gzbuf(i+nfrpar+1)
	    enddo
        enddo
	  Z(nzfr+1)=hisq   ! to save 1 BroadCast
	else
	  gzbuf(1)=hisq
        call mpi_Send(gzbuf,nn,mpi_data,0,0,mpi_comi,mpi_err)        ! send data
      endif
      call MPI_BCast(G,nfrpar,mpi_data,0,mpi_comi,mpi_err)
      call MPI_BCast(Z,nzfr+1,mpi_data,0,mpi_comi,mpi_err)
      hisq=Z(nzfr+1)        
	deallocate(gzbuf,df,dfn,dummi,hi)     ! Sap: MPI
!          call profile(4)   !*****    almost all time if NED>5000 !!!

      RETURN
               END        ! sgzm
              SUBROUTINE SGZbp(a,exda,funct)
!---------------  author: I.M. Sitnik, 2009

!-----SUBROUTINE SGZ SETS UP CHI^2,G(GRADIENT OF S) AND
!-----Z(APPROXIMATE COVARIANCE MATRIX)
      IMPLICIT REAL*8 (A-H,O-Z)
	character*19 filnewar
      COMMON /NEDm/NED(2) !/X/X(20)
	common/fuminput/hisqmax,integx,n1,n2
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/fumirs/iflname,ioutput,filnewar(4)
	dimension a(npar),df(npar)
	dimension exda(*)

      K2=0
	nb=0
	uplim=hisqndf*hisqmax
      open(999,file=filnewar(4))
	write(999,*)'          N    (y-F(x))/err   hi^2',
     *	'      first x     last x'    
      DO L1=1,ned(1)
         y=funct(exda(k2+3),a,df)
         dysig=(EXDA(K2+1)-Y)/EXDA(K2+2)
	   hisqi=dysig**2
         if(hisqi.gt.uplim) then
	      nb=nb+1
	      write(999,'(i6,i8,1p4e12.3)')
     *	  nb,L1,dysig,hisqi,exda(k2+3),exda(k2+ned(2))
         endif
         K2=K2+NED(2)
      enddo !  L1=1,ned(1)
	close(999)
      RETURN
               END        ! sgzm
              SUBROUTINE SGZgrhi(a,exda,funct)
!---------------  author: I.M. Sitnik, 2009

!-----SUBROUTINE SGZ SETS UP CHI^2,G(GRADIENT OF S) AND
!-----Z(APPROXIMATE COVARIANCE MATRIX)
      IMPLICIT REAL*8 (A-H,O-Z)
	parameter(nstep=100)
	character*19 filnewar
	allocatable ar(:)
      COMMON /NEDm/NED(2) !/X/X(20)
	common/fuminput/hisqmax,integx,n1,n2
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/fumirs/iflname,ioutput,filnewar(4)
	dimension a(npar),df(npar)
	dimension exda(*)

      K2=0
      open(999,file=filnewar(2))

      alim=1d37
	blim=-1d37    
      DO L1=1,ned(1)
         y=funct(exda(k2+3),a,df)
         dysig=(EXDA(K2+1)-Y)/EXDA(K2+2)
	   hisqi=dysig**2
	   if(hisqi.lt.alim)alim=hisqi
	   if(hisqi.gt.blim)blim=hisqi
         K2=K2+NED(2)
      enddo !  L1=1,ned(1)

	alimn=alim/hisqndf
	blimn=blim/hisqndf
	na=log10(alimn)-1
	if(na.lt.-4) na=-4
	nb=log10(blimn)+1
	step=1d0*(nb-na)/(nstep-1)
      allocate(ar(100))
	ar=0d0

	k2=0
      DO L1=1,ned(1)
         y=funct(exda(k2+3),a,df)
         dysig=(EXDA(K2+1)-Y)/EXDA(K2+2)
	   hisqin=dysig**2/hisqndf
	   hisqlog=log10(hisqin)-na
	   j=hisqlog/step+1
	   if(j>0) ar(j)=ar(j)+1d0
	   nar=nar+1
         K2=K2+NED(2)
      enddo !  L1=1,ned(1)

	st=na-0.5d0*step
      do i=1,nstep
	  arg=st+i*step
        write(999,'(1p3e12.3)') arg, ar(i)
	enddo
	deallocate(ar)
	close(999)   	    
      RETURN
               END        ! sgzm


               SUBROUTINE SGZ2par(exda,funct)
!---------------  author: I.M. Sitnik, 2007

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(maxpar=2)
 	parameter(rp=1d-17,ap=1d-37)
      COMMON /G2par/G(2)/A2par/A(2)/PL2par/PL(2)
	common /R2par/R(2)/der2par/indderiv(2)
      COMMON/NEDm/NED(2)
      common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/z2par/z(3)
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	dimension dummi(2),df(2),a2(2),hi(2)
	dimension exda(*)
	externaL funct

      K2=0
      hisq=0.D0
	g(1)=0d0
	g(2)=0d0
      Z(1)=0.D0
      Z(2)=0.D0
      Z(3)=0.D0
	hi(1)=pL(1)*0.01d0
	hi(2)=pL(2)*0.01d0

      DO L1=1,ned(1)
         df(1)=0d0
	   df(2)=0d0
         SIG=EXDA(K2+2)
	   y=funct(exda(k2+3),a,df)
         dysig=(Y-EXDA(K2+1))/sig
         hisq=hisq+dysig**2

	   do n=1,Nnoderiv
	      i=indderiv(n)
		  AI=A(i)
            A(i)=AI+HI(i)
		  df(i)=(FUNCT(exda(k2+3),a,dummi)-Y)/HI(i)
            A(i)=AI
         enddo

	   df1=df(1)/sig
	   df2=df(2)/sig
         G(1)=G(1)+df1*dysig
         G(2)=G(2)+DF2*dysig
         Z(1)=Z(1)+df1*df1
         Z(2)=Z(2)+df1*df2
         Z(3)=Z(3)+df2*df2
         K2=K2+NED(2)
      enddo !  L1=1,ned(1)

      RETURN
                   END

                   SUBROUTINE MONITm(hoL,a,ai,sigma,r,indfix)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007

!-----ITERATION PROGRESS OUTPUT
      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	  common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	  common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	  common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	  common/NEDm/NED(2)
	  dimension a(npar),ai(npar),sigma(npar),r(npar),indfix(npar)
	  character*80 formiter(2)
	data formiter(1)/
     *"(/3x'ITER='I3' EC='1pD11.4' kappa='D10.3' lambda='D10.3/)"/
      data formiter(2)
     */"(14x,'chi^2/NDF=',1pD11.4,6x,'chi^2=',D11.4/)"/
	character*9 hpar,hdev,hch,hsta*8,hcor*11   
	data hpar/'PARAMETER'/,hsta/'STANDARD'/,hcor/'CORRELATION'/
	character*13 hnum,hval*5,hfac*6
	data hnum/'NUMBER & NAME'/,hval/'VALUE'/,hdev/'DEVIATION'/
	data hfac/'FACTOR'/,hch/'INCREMENT'/
	character*105 ht(8,2)
	data ht(1,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY"/
	data ht(1,2)/' '/
      data ht(2,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY IN"/
	data ht(2,2)/"PART WHILE SOME PARAMETERS ARE FIXED ON BOUND"/
      data ht(3,1)/"  MINIMISATION IS TERMINATED:"/
	data ht(3,2)/"ALL PARAMETERS ARE FIXED ON BOUND"/
      data ht(4,1)/"  ITERATION LIMIT IS REACHED"/
	data ht(4,2)/" "/
      data ht(5,1)/"  MINIMISATION IS FINISHED SUCCESSFULLY IN PART"/
	data ht(5,2)/"WHILE SOME PARAMETERS ARE UNDEFINED"/
      data ht(6,1)/"  MINIMISATION IS TERMINATED AS NO FURTHER"/
	data ht(6,2)/"DECREASE IN CHISQ IS OBTAINABLE"/
      data ht(7,1)/" ALL PARAMETERS ARE FIXED"/
	data ht(7,2)/" "/
      data ht(8,1)/"  MINIMISATION IS TERMINATED AS ALL PARAMETERS"/
	data ht(8,2)/"EITHER FIXED ON BOUND OR HAVE INFINITE ERROR"/
	character*58 hformat(4)
	data hformat(1)/"(I12,1x,a15,1p4D17.5)"/      
      data hformat(2)/"(I12,1x,a15,1pD17.5,'      ON BOUND')"/
      data hformat(3)
     */"(I12,1x,a15,1pD17.5,6X,'INFINITE ERROR ESTIMATION')"/
      data hformat(4)/"(I12,1x,a15,1pD17.5,6X,'FIXED PARAMETER')"/
	character*(*) hoL(Npar)


	ECndf=EC/(ned(1)-Nfrpar+1)
!      write(ipri,formiter(1)) Iiterc,ECndf,AKAPPA,ALAMBD
!      write(ipri,formiter(2)) hisqndf,hisq
! 	write(ipri,'(9xA9,16xA9,7xA9,9xA11,6x,A9)')hpar,hpar,hsta
!     *,hcor,hpar
!	write(ipri,'(9xA13,12xA5,12xA9,8xA6,11xA9)') hnum,hval,hdev
!     *,hfac,hch
      DO I=1,Npar
         ipr=indfix(i)+1
	   da=a(i)-ai(i)
!	   if(ipr.eq.1) then
!	      write(ipri,hformat(ipr)) I,hoL(i),A(I),SIGMA(I),R(I),da
!	   eLse	 
!	      write(ipri,hformat(ipr)) I,hoL(i),A(I)
!         endif
	enddo
	if(nbad.ne.0) then
	percent=100d0*nbad/ned(1)
!	write(ipri,'(/i6"("f4.1"%)"A40)')nbad,percent,
!     &	' events are ignored due to huge hi^2'
      endif

      IF (iendfLg.eq.0) return
!	write(ipri,'(/"iendfLg=",I2,":",a49,a50/)')iendfLg,ht(iendfLg,1:2)
	return
               END
               subroutine mgconvm(indm,z,r,indfix,indfrpar1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  Z-matrix transformation

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension indm(Nfrpar,Nfrpar)
	dimension z(nzfr),r(npar),indfix(npar),indfrpar1(nfrpar)
	dimension km(nfrpar),rc(nfrpar),Zd(nfrpar)
	equivaLence(n,Nfrpar1)
	   
      ifixindef=0
	IF (N.Lt.1) RETURN
	  	         
	Apn=ap*N
	apnrp=apn/rp
      APS=SQRT(1.d0/Apn)

      DO I=1,N  !------------------ cluster
	   Zd(i)=Z(indm(i,i))
         rc(I)=MAX(Zd(i),APn)
      enddo ! i=1,n      !------------------ end cluster

      do j=1,n
        zcmi=1d+37
	  i=j
        do k=j,n
           zklmax=0.
           zkk=zd(k)
	     if(zkk<Apn) zkk=MAX(RP*ABS(rc(k)),rp*abs(zkk),APn)
		 do L=j,k-1
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zklmax) zklmax=abszkL
           enddo ! L=j,n
           do L=k+1,n
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zklmax) zklmax=abszkL
           enddo ! L=j,n

           temp=zklmax/sqrt(zkk)
           if(temp.Lt.zcmi) then
	        zcmi=temp
              i=k
           endif
        enddo ! k=1,n
        km(j)=i

        if(i.ne.j) then
!---------------------- Exchange i-th and j-th strings and coLumns of the matrix
           sav=zd(i)
           zd(i)=zd(j)
           zd(j)=sav  

           do k=1,j-1
	        ki=indm(k,i)
	        kj=indm(k,j)
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

           do k=j+1,i-1
	        ki=indm(k,i)
	        kj=indm(k,j)
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

           do k=i+1,n
	        ki=indm(k,i)
	        kj=indm(k,j)
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

        endif ! i.ne.j  !-------------------End Exchange i-th and j-th ... 

        zjj=zd(j)
        rpn=rp*max(abs(rc(i)),abs(zjj),apnrp) !

        IF(Zjj.LE.RPn) then
          Zjj=RPn
          rc(i)=-ABS(rc(i))
        endif

        zjj=1.d0/sqrt(zjj)
        arp=aps/zjj !qz(j,j)
        ZjLMax=0d0

        DO k=1,j-1
            Zjk=ABS(Z(indm(k,j)))
            IF(Zjk.gt.ZjkMax) ZjkMax=Zjk
        enddo ! k=1,n
        DO k=j+1,N
            Zjk=ABS(Z(indm(j,k)))
            IF(Zjk.gt.ZjkMax) ZjkMax=Zjk
        enddo ! k=1,n
	  if(ZjkMax.gt.arp) Zjj=Zjj*arp/ZjkMax

        Zd(j)=Zjj

        do k=n,j+1,-1   !------------------ cluster 
           kj=indm(k,j)
           Z(kj)=Z(kj)*Zjj !
        enddo ! k=n,1,-1
        do k=j-1,1,-1
           kj=indm(k,j)
           Z(kj)=Z(kj)*Zjj !
        enddo ! k=n,1,-1   !------------------ end cluster

        do k=n,j+1,-1
           kj=indm(k,j)
           Zkj=Z(Kj) ! *qZ(j,j)
           Zd(k)=Zd(k)-Zkj**2
           do L=k-1,1,-1   !------------------ cluster
              Lk=indm(L,k)
              Z(Lk)=Z(Lk)-Z(indm(L,j))*Zkj
           enddo ! L=k,1,-1  !------------------ end cluster

           Z(Kj)=-Zkj*Zjj ! -C
        enddo ! k=n,i+1,-1
      enddo ! j=1,n  ----------------------------------------------------

      DO I=1,N
         D=zd(I)**2
         DO L=I+1,n
            D=D+Z(indm(L,i))**2
         enddo ! L=k,n
         Zd(I)=D

         DO K=I+1,n      
            D=z(indm(k,i))*zd(k)
            DO L=k+1,n !------------------ cluster if to make array
               D=D+Z(indm(L,i))*Z(indm(L,k))
            enddo ! L=k,n   !------------------ end cluster
            Z(indm(k,i))=D
         enddo ! k=i,n
      enddo ! i=1,n  

      do i=n,1,-1
        j=km(i)
        if(j.ne.i) then
!-----------------------Exchange i-th and j-th strings and coLumns of the matrix
           sav=zd(i)
           zd(i)=zd(j)
           zd(j)=sav  
           do k=1,i-1
	        ki=indm(k,i) 
	        kj=indm(k,j) 
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

           do k=i+1,j-1
	        ki=indm(k,i) 
	        kj=indm(k,j) 
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

           do k=j+1,n
	        ki=indm(k,i) 
	        kj=indm(k,j) 
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
           enddo ! k=1,n

       endif 
      enddo    ! i=n,1,-1 

      DO I=1,N
	   j=indfrpar1(i)
	   Z(indm(i,i))=zd(i)
   	   absz=abs(Zd(i))
	   absrc=abs(rc(i))
         IF(ABSZ>APS.AND.ABSrc>1d0.OR.ABSrc>APS.AND.ABSZ>1d0) then
            r(j)=rc(I)/ABSrc/AP
         eLse
            r(j)=absz*rc(I)
         endif
		 if(r(j).Lt.0d0) then
		    indfix(j)=2
              ifixindef=ifixindef+1
         endif
      enddo ! i=1,N

      RETURN
               end
               subroutine mgconv2
      IMPLICIT REAL*8 (A-H,O-Z)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common /z2par/z(3)/R2par/R(2)

      ifixindef=0
      zm1=Z(1)
      zm2=Z(2)
	  zm2q=zm2**2
	  zm3=Z(3)
	  if(zm1.Le.0d0.or.zm3.Le.0d0) then
	     ifixindef=2
		 return
      endif 

      det=zm3-zm2q/zm1
	if(det.Le.1d-19) det=1d-19
	z(3)=1d0/det
      z(1)=1d0/zm1+zm2q/zm1**2*z(3)
	z(2)=-zm2/zm1*z(3)

      r(1)=z(1)*zm1
      r(2)=r(1)

	  RETURN
                      end

                  subroutine makeindm(indm,n)
      dimension indm(n,n)
	m=0   
 	   do i=1,N
	      do j=1,i
	         m=m+1
		     indm(j,i)=m
		     indm(i,j)=m
            enddo
	   enddo
      return
                     end



                   SUBROUTINE fumerrexd(A,exda,funct,z,pl,indfrpar1)
!---------------  author: I.M. Sitnik, 2007
!--------------- output array "arr": dimension (ned(2),ned(1))
!--------------- arr(1,i) - contribution to chisq for i-exda-point
!--------------- arr(2,i) - error for function
!--------------- arr(3:ned(2),i) x-coordinates of i-exda-point

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	character*19 filnewar
      COMMON /NEDm/ Ned(2)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumirs/iflname,ioutput,filnewar(5)
	dimension exda(ned(2),ned(1))
	dimension pL(npar),indfrpar1(npar),df(npar)
	dimension a(npar),dfn(npar),z(Nzfr)
!---------------------------CHI SQUARED
      open(999,file=filnewar(5))
	write(999,'(10x"Y_th"6x"err_th"3x"Y_exp-Y_th   Chi**2"
     &9x"Y_exp"5x"sigma"8x"x(i)...")')

      DO j=1,ned(1)
         SIG=EXDA(2,j)
	   df=0d0
	   y=funct(exda(3,j),a,df)

         DO n=1,Nfrpar1
            i=indfrpar1(n)
	      if(df(i).eq.0d0) then
               Amem=A(I)
               HI=0.01D0*pL(I)
               A(I)=Amem+HI
		     DF(I)=(FUNCT(exda(3,j),a,dummi)-Y)/HI
               A(I)=Amem
            endif
		  dfn(n)=df(i) 
         enddo
		 	 
         erfun=scaLm(z,dfn,nfrpar1)
	   dif=exda(1,j)-y
	   hiq=(dif/sig)**2  
	   write(999,'(I5,1p4e11.3,3x,2e11.3,3x,7e11.3,9(/77x7e11.3))')
     &		  j,y,erfun,dif,hiq,exda(1:ned(2),j)
      enddo
	close(999)
      RETURN
                     END

           SUBROUTINE fumerrfun(A,exda,funct,z,pl,indfrpar1)
!---------------  author: I.M. Sitnik, 2007
!---------------  error-corridor for funct
!--------------- aLim:   min vaLue of x(ix)
!--------------- bLim:   max vaLue of x(ix)
!--------------- nstep:  number of points
!--------------- ipr  -  fiLe associated number


      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv,indderivi
	parameter (nstep=100)
	character*19 filnewar
      COMMON /NEDm/ Ned(2)
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumirs/iflname,ioutput,filnewar(5)
	dimension exda(ned(2)*ned(1)),z(*)
	dimension a(npar),df(npar),pL(npar),dfn(npar),indfrpar1(npar)

      alim=1d37
	blim=-1d37
	L=3
	do i=1,ned(1)
         if(exda(L).lt.alim) alim=exda(L)
         if(exda(L).gt.blim) blim=exda(L)
	   L=L+3
	enddo
	dlim=(blim-alim)
	dlim1=dlim*0.1d0
	alim=alim-dlim1
	blim=blim+dlim1
	dx=(bLim-aLim)/(nstep-1)

      open(999,file=filnewar(3))
      DO j=1,nstep
	   x=aLim+(j-1)*dx
	   df=0d0
	   y=funct(x,a,df)
          
         DO n=1,Nfrpar1
            i=indfrpar1(n)
	      if(df(i).eq.0) then
               Amem=A(I)
               HI=0.01D0*pL(I)
               A(I)=Amem+HI
		     DF(I)=(FUNCT(x,a,df)-Y)/HI
               A(I)=Amem
            endif
		  dfn(n)=df(i) 
         enddo

         er=scaLm(z,dfn,nfrpar1)
	   dw=y-er
	   up=y+er
	   write(999,'(1pe12.3,3x,3e12.4)') x,y,dw,up
      enddo
	close(999)
      RETURN
                     END
               function SCALm(Z,df,n)
!-----SUBROUTINE SCAL CALCULATES ER=VARIANCE OF THEORETICAL FUNCTION Y
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2009
      IMPLICIT REAL*8 (A-H,O-Z)
	dimension Z(*),df(n)
 
	dispii=0d0
	dispij=0d0
	m=0
      DO I=1,N
         DO L=1,I-1
	      m=m+1
            dispij=dispij+Z(m)*DF(I)*DF(L)
         enddo
	   m=m+1
	   dispii=dispii+Z(m)*DF(I)**2
      enddo
	disp=dispii+2d0*dispij
      scaLm=sqrt(disp)
      RETURN
                           END


			function fstrawd(x,a,df)
!---------------  author: I.M. Sitnik, 2007
!--------------- internaL function for tracks via straws

	impLicit reaL*8(a-h,o-z)
      dimension x(2),a(2),df(2)

      up=a(1)*x(1)+a(2)-x(2)
	dw=1d0+a(1)**2
	f=abs(up)/sqrt(dw)+1d-19
	up1=up*(dw*x(1)-a(1)*up)

	dw2=dw*f
	dw1=dw2*dw
	df(1)=up1/dw1
	df(2)=up/dw2

      fstrawd=f
	return
			end
	                     function fumstraw(as,bs,exda,nex)
!---------------  author: I.M. Sitnik, 2007
!--------------- user caLL for tracks via straws x=as*z+bs
!--------------- chisqndf=fumstraw(as,bs,exda), where
!                                 exda : input array of experimentaL points
!                                 exda(1,i): space radius (not time)
!                                 exda(2,i): error  
!                                 exda(3,i): z-coordinate of wire (aLong track) 
!                                 exda(4,i): x-coordinate of wire (transversaL to z)
!                                 shouLd be the same units for exda(1:4,i)
!                                 nex: number of experimentaL poits    
!   z-coordinate of 1st exp-point shouLd be Least, and of Last exp-point shouLd be Largest of vice versa  

	impLicit reaL*8(a-h,o-z)
	parameter(npar=2,Lexda=4)
	common/nparfum/Np,Nfrpar,Nfrpar1,Nzfr,nx,niterc
      dimension exda(Lexda,nex),hisq(4)
      dimension ab(2,6,4)
	externaL fstrawd

	x1=exda(3,1)
	dx=exda(3,nex)-x1

	y1=exda(4,1)
	dy=exda(4,nex)-y1
	r1=exda(1,1)
      r2=exda(1,nex)

!--------------------- make 4 sets of initiaL vaLues of parameters   
	dxq=dx**2
	dyq=dy**2
	dxdy=dx*dy

      c=r1+r2
	cq=c**2
	det=dxq+dyq-cq
	absdet=abs(det)+1d-37
	sqdet=sqrt(absdet)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,1)=a1
	ab(1,1,2)=a2
	ab(2,1,1)=y1-a1*x1-r1*sqrt(1.+a1**2)
	ab(2,1,2)=y1-a2*x1+r1*sqrt(1.+a2**2)
	ab(1,4,1)=0.5d0
	ab(1,4,2)=0.5d0
	ab(2,4,1)=10.5d0
	ab(2,4,2)=10.5d0

      c=r2-r1
	cq=c**2
	det=dxq+dyq-cq
	sqdet=sqrt(det)
      a1=(-dxdy-c*sqdet)/(cq-dx**2)
      a2=(-dxdy+c*sqdet)/(cq-dx**2)
	ab(1,1,3)=a1
	ab(1,1,4)=a2
	ab(2,1,3)=y1-a1*x1+r1*sqrt(1.+a1**2)
	ab(2,1,4)=y1-a2*x1-r1*sqrt(1.+a2**2)
	ab(1,4,3)=0.5d0
	ab(1,4,4)=0.5d0
	ab(2,4,3)=10.5d0
	ab(2,4,4)=10.5d0
!---------------------------------------end of make.....
      do i=1,4
	   hisq(i)=fumi2par(ab(1,1,i),exda,Lexda,nex,fstrawd,1)
	enddo
	mbest=1
      hisqm=hisq(1)
	do i=2,4
         if(hisq(i).Lt.hisqm) then
	      mbest=i
	      hisqm=hisq(i)
         endif
      enddo

	hisqndf=fumi2par(ab(1,1,mbest),exda,Lexda,nex,fstrawd,10)
      as=ab(1,1,mbest)
	bs=ab(2,1,mbest)   
      fumstraw=hisqndf
	return
	         end


               subroutine mgconvmo(indm,z,r,indfix,indfrpar1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  Z-matrix transformation

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	dimension indm(Nfrpar,Nfrpar)
	dimension z(nzfr),r(npar),indfix(npar),indfrpar1(nfrpar)
	dimension km(nfrpar),rc(nfrpar)
	equivaLence(n,Nfrpar1)
	   
      ifixindef=0
	IF (N.Lt.1) RETURN
	  	         
	Apn=ap*N
	apnrp=apn/rp
      APS=SQRT(1.d0/Apn)

      DO I=1,N  !------------------ cluster
         rc(I)=MAX(Z(indm(i,i)),APn)
      enddo ! i=1,n      !------------------ end cluster

      do j=1,n
        zcmi=1d+37
        do k=j,n
           zndmk=0.
           zkk=z(indm(k,k))
	     if(zkk<Apn) zkk=sqrt(MAX(RP*ABS(rc(k)),rp*abs(zkk),APn))
		 do L=j,k-1
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n
           do L=k+1,n
              abszkL=abs(z(indm(k,L)))
              if(abszkL.gt.zndmk) zndmk=abszkL
           enddo ! L=j,n

           temp=zndmk/sqrt(zkk)
           if(temp.Lt.zcmi) then
	        zcmi=temp
              i=k
           endif
        enddo ! k=1,n
        km(j)=i

        if(i.ne.j) then
!---------------------- Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri

           do k=1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=j+1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

        endif ! i.ne.j  !-------------------End Exchange i-th and j-th ... 

        i=j
		ii=indm(i,i)
        zii=z(ii)
        rpn=rp*max(abs(rc(i)),abs(zII),apnrp) !

        IF(ZII.LE.RPn) then
          ZII=RPn
          rc(I)=-ABS(rc(I))
        endif

        zii=1.d0/sqrt(zii)
        arp=aps/zii !qz(i,i)
        ZiLMax=0d0
        AM=1d0

        DO L=1,i-1
            ZiL=ABS(Z(indm(L,i)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
        DO L=i+1,N
            ZiL=ABS(Z(indm(i,L)))
            IF(ZiL.gt.ZiLMax) ZiLMax=ZiL
        enddo ! L=1,n
	  if(ZilMax.gt.arp) AM=arp/ZiLMax

        ZII=ZII*AM
        Z(ii)=ZII

        do L=n,i+1,-1   !------------------ cluster 
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1
        do L=i-1,1,-1
           iL=indm(i,L)
           Z(iL)=Z(iL)*ZII !
        enddo ! L=n,1,-1   !------------------ end cluster

        do k=n,i+1,-1
           ki=indm(k,i)
           C=Z(Ki) ! *qZ(I,I)

           do L=k,1,-1   !------------------ cluster
              Lk=indm(L,k)
              Z(Lk)=Z(Lk)-Z(indm(L,i))*C
           enddo ! L=k,1,-1  !------------------ end cluster

           Z(Ki)=-C*ZII ! -C
        enddo ! k=n,i+1,-1
      enddo ! j=1,n  ----------------------------------------------------

      DO I=1,N
         DO K=I,n      
            D=0d0
            DO L=k,n !------------------ cluster if to make array
               D=D+Z(indm(L,i))*Z(indm(L,k))
            enddo ! L=k,n   !------------------ end cluster
            Z(indm(k,i))=D
         enddo ! k=i,n
      enddo ! i=1,n  

      do i=n,1,-1
        j=km(i)
        if(j.ne.i) then
!-----------------------Exchange i-th and j-th strings and coLumns of the matrix
           sav=z(indm(i,i))
           z(indm(i,i))=z(indm(j,j))
           z(indm(j,j))=sav  
           ri=rc(i)
           rc(i)=rc(j)
           rc(j)=ri
           do k=1,i-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=i+1,j-1
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

           do k=j+1,n
              sav=z(indm(k,i))
              z(indm(k,i))=z(indm(k,j))
              z(indm(k,j))=sav
           enddo ! k=1,n

       endif 
      enddo    ! i=n,1,-1 

      DO I=1,N
	   j=indfrpar1(i)
   	   absz=abs(Z(indm(i,i)))
	   absrc=abs(rc(i))
         IF(ABSZ>APS.AND.ABSrc>1d0.OR.ABSrc>APS.AND.ABSZ>1d0) then
            r(j)=rc(I)/ABSrc/AP
         eLse
            r(j)=absz*rc(I)
         endif
		 if(r(j).Lt.0d0) then
		    indfix(j)=2
              ifixindef=ifixindef+1
         endif
      enddo ! i=1,N

      RETURN
               end
               subroutine mgconvopt(indm,z,r,indfix,indfrpar1)
!---------------   author: I.N. SiLin
!---------------  upgrade: I.M. Sitnik, 2007
!---------------  Z-matrix transformation

      IMPLICIT REAL*8 (A-H,O-Z)
	integer*2 indfrpar,indfrpar1,indboun,indfix,indderiv
	parameter(rp=1d-17,ap=1d-37)
	common/gLofum/hisqndf,ipri,ifixindef,nbad,nset
	common/nparfum/Npar,Nfrpar,Nfrpar1,Nzfr,nx,niterc,Nnoderiv
	common/fumoutput/hisq,iendfLg,iiterc,akappa,aLambd,EC
	dimension indm(Nfrpar,Nfrpar)
	dimension z(nzfr),r(npar),indfix(npar),indfrpar1(nfrpar)
	dimension km(nfrpar),rc(nfrpar),Zd(nfrpar)
	equivaLence(n,Nfrpar1)
	data nparmem/0/
	   
      ifixindef=0
	IF (N.Lt.1) RETURN
!        call profile(1)	  	         
	Apn=ap*N
	apnrp=apn/rp
      APS=SQRT(1.d0/Apn)

      DO I=1,N  !------------------ cluster
	   Zd(i)=Z(indm(i,i))
         rc(I)=MAX(Zd(i),APn)
      enddo ! i=1,n      !------------------ end cluster

      do j=1,n
        zcmi=1d+37
	  i=j
        do k=j,n
           zklmax=0.
           zkk=zd(k)
	     if(zkk<Apn) zkk=MAX(RP*ABS(rc(k)),rp*abs(zkk),APn)
	     Lk=indm(j,k)
		 do L=j,k-1
              abszkL=abs(z(Lk))
              if(abszkL.gt.zklmax) zklmax=abszkL
	        Lk=Lk+1
           enddo ! L=j,n
	     Lk=indm(k,k)+k
           do L=k+1,n
              abszkL=abs(z(Lk))
              if(abszkL.gt.zklmax) zklmax=abszkL
	        Lk=LK+L
           enddo ! L=j,n

           temp=zklmax/sqrt(zkk)
           if(temp.Lt.zcmi) then
	        zcmi=temp
              i=k
           endif
        enddo ! k=1,n
        km(j)=i

        if(i.ne.j) then
!---------------------- Exchange i-th and j-th strings and coLumns of the matrix
           sav=zd(i)
           zd(i)=zd(j)
           zd(j)=sav  


           ki=indm(1,i)
           kj=indm(1,j)
           do k=1,j-1
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
	        ki=ki+1
	        kj=kj+1
           enddo ! k=1,n

           kj=indm(j,j)+j
	     ki=indm(j,i)+1
           do k=j+1,i-1
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
	        ki=ki+1
	        kj=kj+k
           enddo ! k=1,n

           ki=indm(i,i)+i
	     kj=indm(i,j)+i
           do k=i+1,n
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
	        ki=ki+k
	        kj=kj+k
           enddo ! k=1,n

        endif ! i.ne.j  !-------------------End Exchange i-th and j-th ... 

        zjj=zd(j)
        rpn=rp*max(abs(rc(i)),abs(zjj),apnrp) !

        IF(Zjj.LE.RPn) then
          Zjj=RPn
          rc(i)=-ABS(rc(i))
        endif

        zjj=1.d0/sqrt(zjj)
        arp=aps/zjj !qz(j,j)
        ZjLMax=0d0

        kj=indm(1,j)
	  kj1=kj
        DO k=1,j-1
            Zjk=ABS(Z(kj))
            IF(Zjk.gt.ZjkMax) ZjkMax=Zjk
	      kj=kj+1
        enddo ! k=1,n
        kj=indm(j,j)+j
	  kj2=kj
        DO k=j+1,N
            Zjk=ABS(Z(kj))
            IF(Zjk.gt.ZjkMax) ZjkMax=Zjk
	      kj=kj+k
        enddo ! k=1,n
	  if(ZjkMax.gt.arp) Zjj=Zjj*arp/ZjkMax

        Zd(j)=Zjj

        do k=1,j-1   !------------------ cluster 
           Z(kj1)=Z(kj1)*Zjj
           kj1=kj1+1
        enddo ! k=n,1,-1
        do k=j+1,n
           Z(kj2)=Z(kj2)*Zjj
	     kj2=kj2+k
        enddo ! k=n,1,-1   !------------------ end cluster

        kj=indm(n,j)
        do k=n,j+1,-1
           Zkj=Z(Kj)
           Zd(k)=Zd(k)-Zkj**2
	     Lk=indm(k,k)-1
           do L=k-1,1,-1   !------------------ cluster
              Z(Lk)=Z(Lk)-Z(indm(L,j))*Zkj
	        Lk=Lk-1
           enddo ! L=k,1,-1  !------------------ end cluster

           Z(Kj)=-Zkj*Zjj
	     kj=kj-k+1
        enddo ! k=n,i+1,-1
      enddo ! j=1,n  ----------------------------------------------------

      DO I=1,N
         D=zd(I)**2
	   Li=indm(i,i)+i
	   ki=LI
         DO L=I+1,n
            D=D+Z(Li)**2
	      Li=Li+L
         enddo ! L=k,n
         Zd(I)=D
         DO K=I+1,n
            D=z(ki)*zd(k)
	      Lk=indm(k,k)+k
	      Li=indm(k,i)+k
            DO L=k+1,n
               D=D+Z(Li)*Z(Lk)
	         Lk=Lk+L
	         Li=Li+L
            enddo ! L=k,n   !------------------ end cluster
            Z(ki)=D
            ki=ki+k
         enddo ! k=i,n
      enddo ! i=1,n  

      do i=n,1,-1
        j=km(i)
        if(j.ne.i) then
!-----------------------Exchange i-th and j-th strings and coLumns of the matrix
           sav=zd(i)
           zd(i)=zd(j)
           zd(j)=sav
           ki=indm(1,i)
           kj=indm(1,j)
           do k=1,i-1
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
              ki=ki+1 
              kj=kj+1 
           enddo ! k=1,n

           ki=indm(i,i)+i
	     kj=indm(j,i)+1
           do k=i+1,j-1
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
              ki=ki+k 
              kj=kj+1 
           enddo ! k=1,n

           ki=indm(j,i)+j
	     kj=indm(j,j)+j
           do k=j+1,n
              sav=z(ki)
              z(ki)=z(kj)
              z(kj)=sav
	        ki=ki+k
	        kj=kj+k
           enddo ! k=1,n

       endif 
      enddo    ! i=n,1,-1 

      DO I=1,N
	   j=indfrpar1(i)
	   Z(indm(i,i))=zd(i)
   	   absz=abs(Zd(i))
	   absrc=abs(rc(i))
         IF(ABSZ>APS.AND.ABSrc>1d0.OR.ABSrc>APS.AND.ABSZ>1d0) then
            r(j)=rc(I)/ABSrc/AP
         eLse
            r(j)=absz*rc(I)
         endif
		 if(r(j).Lt.0d0) then
		    indfix(j)=2
              ifixindef=ifixindef+1
         endif
      enddo ! i=1,N
!        call profile(1)	  	         

      RETURN
               end
